! ################    CLIMATE DEFINITIONS   ###############

!
! 0 
! 1
!
#define VEGGIE 0

!
! 0 do not use the icemask (LOVECLIM basic version LLN)
! 1 use the provided icemask (icemask.dat)   
!  
#define IMSK 1

!
! 0 use the original comatm.h (LLN compatibility)
! 1 use the comatm FORTRAN90 module (GRISLI compatibility)
!  
#define COMATM 1

!
! 0 use the water routing provided by "labas.dat"
! 1 use the surface water routing as computed in "routageEAU"
!  
#define ROUTEAU 1

!
! 0 LLN's version of evapotranspiration (BUG included)
! 1 Do not use evapotranspiration (no BUG fix evident)
!  
#define EVAPTRS 1

!
! 0 LOVECLIM standard version
! 1 Do not allow oceanic evaporation through sea-ice
!  
#define EVAPSI 0

!
! 0 No additional radiative forcing from dust
! 1 Additional radiative forcing from dust (after Claquin et al., 2003)
!  
#define CLAQUIN 0

! ################  WATER ISOTOPES DEFINITIONS  ###############

!
! 0 do not compute water isotopes in the atmosphere
! 1 water isotopes are advected in the atmosphere without fractionnation
! 2 water isotopes computed following MJ79's methodology and definitions
! 3 water isotopes computed according to the full definition of Roche (2011)
!  
#define ISOATM 0

!
! 0 do not link surface isotopic content of land to atmosphere (fixed values for rmoisg)
! 1 water isotopes are computed in surface water content (bmoisg prognostic)
!  
#define ISOLBM 0

!
! 0 do not link surface oceanic isotopic content to atmosphere (fixed values for ratio_oceanatm)
! 1 water isotopes are computed in ocean but not updated in the surface ocean for atmosphere (semi-coupled mode) Requires ISOATM >= 2
! 2 water isotopes are computed in ocean ("ratio_ocean" prognostic) Requires ISOATM >= 2
!  
#define ISOOCN 0
! ################    ICE-SHEET DEFINITIONS    ###############

!
! 0 do not include any code for ice-sheets components
! 1 include agISM ice-sheet source code in compilation (do not start)
! 2 include GRISLI ice-sheet code and start it (Northern Hemisphere for now)
!  
#define ISM 2

! 
! 0  if ISM is not 2 this flag should be 0 as well
! 1  couple GRISLI and ECBilt using the snow computed in ECBilt
! 2  couple GRISLI and ECBilt using the total precipitation (snow and rain)
!  
#define CPLTYP 1

!
! 0  transmit the climate fields from ECBilt with an interpolation only
! 1  use vertical downscaling for temperatures when coupling GRISLI and ECBilt
!  
#define DOWNSTS 1

! 0 calved ice of GRISLI is not further regarded 
! 1 calved ice of GRISLI is given to iceberg module in the form of a flux [m3/s]
! 2 calving flux is put into the ocean directly as freswhwaterflux [m3/s]

#define CALVFLUX 1 
!
!
! 0 no watercycle between ECBilt and ISM is considerd
! 1 Try water conservation for precipitation/runoff between ECBilt and ISM
!
#define WATGRISCONS 1


! ################    CARBON DEFINITIONS   ###############

!
! 0 no carbon code included in the compilation
! 1 add the LOCH carbon code as in the sdandard version (no start of LOCH)   
! 2 add the carbon cycle of iLOVECLIM (ocean, vegetation and/or atmosphere)
!  
#define CYCC 0

!
! 0 no oceanic carbon cycle with CYCC = 2 (consistency not verified yet)
! 1 oceanic carbon cycle from Six & Maier-Raimer, 1996 with CYCC = 2
!  
#define OCYCC 0

!
! 0 remove the old 14C code from LOVECLIM (LLN code) <= mandatory option when cycc=1
! 1 include the old 14C code from LOVECLIM in compilation (no start)
!  
#define OLDC14 0

!
! 0 no computation of nitrous oxide in the ocean
! 1 add nitrous oxide computation in the ocean
!  
#define OXNITREUX 0

!
! 0 gaz coefficient exchange rate for the carbon independent of wind speed
! 1 gaz coefficient exchange rate for the carbon is function of the wind from ECBilt
! Beware : option number 2 is not functionnal yet!
!  
#define WINDINCC 0

!
! 0 O2 is a diagnostic variable in the ocean only
! 1 O2 is computed as an exchange between the ocean and the atmosphere
! Beware : option number 1 not fully functionnal yet!
!  
#define O2ATM 0

!
! 0 N2O is a diagnostic variable in the ocean only
! 1 N2O is computed as an exchange between the ocean and the atmosphere
! Beware : option number 1 not fully functionnal yet!
!  
#define N2OATM 0

! ################    OUTPUT DEFINITIONS   ###############

!
! 0 output is generated in the old standard version of LOVECLIM
! 1 output is PMIP - compatible
!  
#define PMIP 0

!
! 0 output of iceberg routine not written out in netcdf format 
! 1 output of iceberg routine is written out in netcdf format 
!
#define OUTP_ICBERG 0
! ################    UNKNOWN DEFINITIONS   ###############

!
! 0 no ABEL code
! 1 ABEL code 
!  
#define ABEL 0

!
! 0 no Progress bar
! 1 Progress bar
!
#define PROGRESS 0

!
! 0 no uncorrected freshwater flux in thersf to the ocean
! 1 Laurentide Ice sheet melt, 0.09 Sv (change in thersf.f)
!   WAIS definition present
!
#define UNCORFLUX 0

!
! 0 no uncorrected freshwater flux from landmodel runoff to thersf
! 1 uncorrected freshwater flux (needs ROUTEAU 0 and UNCORFLUX 1)
!
#define UNCORRUNOFF 0

!
! 0 whatever uncorrected fwf is computed in switches do NOT apply it to the ocean
! 1 apply the uncorrected fwf to the ocean, from switches UNCORFLUX, UNCORRUNOFF, WATGRISCONS
!
#define APPLY_UNCORFWF 1

!
! 0 do not apply specific correction for LGM (cf. code in ocycc and clio)
! 1 apply LGM specific corrections. EXPERIMENTAL, use with care!
!
#define LGMSWITCH 0

! ################    THIS IS THE END !!   ###############
