!dmr -- Ajout du choix optionnel des composantes - Thu Dec 17 11:57:35 CET 2009
#include 'choixcomposantes.h'
!dmr -- Ajout du choix optionnel des composantes - Thu Dec 17 11:57:35 CET 2009
!-----|--1--------2---------3---------4---------5---------6---------7-|
!      Ce sous-programme est uns substitution LUDUS à ec_runoff inclus
!       initialement dans landmodel.f 
!
!      Au passage, il a été simplifié par la suppression des inclusifs
!       pour l'ISM == 1 de P. Huybrechts
!
!      Auteur : Didier M. Roche
!      Date   : 04 décembre 2010
!      Derniere modification : Didier M. Roche, 05 juillet 2012
!-----|--1--------2---------3---------4---------5---------6---------7-|

      SUBROUTINE ec_runoff_2(istp)

!-----|--1--------2---------3---------4---------5---------6---------7-|
!       Variables d'entree : 
!       Variables de sorties : 
!-----|--1--------2---------3---------4---------5---------6---------7-|

!-----|--1--------2---------3---------4---------5---------6---------7-|
!
!-----|--1--------2---------3---------4---------5---------6---------7-|

      USE routageEAU_mod, ONLY: eni, enj, flux_per_basin, river_basin

#if ( ISOATM >= 2 )
      USE iso_param_mod, ONLY : ieau, neauiso, ieau18, rsmow, delta
#endif

#if ( WATGRISCONS == 1 )
      USE runoff_coupl, ONLY : runoflECB
#endif

      IMPLICIT NONE

!-----|--1--------2---------3---------4---------5---------6---------7-|
!
!-----|--1--------2---------3---------4---------5---------6---------7-|
#include 'comland.h'
#include 'comunit.h'
#include 'comemic.h'


      INTEGER, INTENT(IN) :: istp

!-----|--1--------2---------3---------4---------5---------6---------7-|
!        Variables locales
!-----|--1--------2---------3---------4---------5---------6---------7-|
      integer   i,j

#if ( ISOATM >= 2 )
      INTEGER :: k
      real, dimension(neauiso) :: variso
      character*10 varisonm
#endif

#if ( WATGRISCONS == 1 .OR. CALVFLUX >= 1)
      real :: mass_grisrunl(nlat,nlon)
      integer :: irunlabelgris
      character*6 :: frunl
      logical :: mexist
cdmr --- factor for converting the precipitation from GRISLI
cdmr ---  (meters3/year) to the current runofl format (m.s-1)
cmab --- will be divided by the area in the code
      real, parameter :: conv_fact = 1.d0/(360.d0*24.d0*3600.d0)
      REAL(KIND=8) :: sumprecipnegat, watconstest
#endif

!-----|--1--------2---------3---------4---------5---------6---------7-|
!        Optional stuff
!-----|--1--------2---------3---------4---------5---------6---------7-|
#define DIAGNOSIS_FLAG 1
#if ( DIAGNOSIS_FLAG == 1 )
      REAL*8 totallnd, totaloc
#endif


!-----|--1--------2---------3---------4---------5---------6---------7-|
!        Inits ...
!-----|--1--------2---------3---------4---------5---------6---------7-|

#if ( DIAGNOSIS_FLAG == 1 )
      totallnd = 0.0d0
      runofo = 0.0d0
#endif

!-----|--1--------2---------3---------4---------5---------6---------7-|
! dmr    Main loop
!        We compute the runoff in each given i,j grid point
!-----|--1--------2---------3---------4---------5---------6---------7-|
      do i=1,nlat
        do j=1,nlon

#if ( ISOATM >= 2 )
          runofl(i,j,:)=0.
#else
          runofl(i,j)=0.
#endif

#if ( WATGRISCONS == 1 ) /* Water conservation flag between ECBilt and GRISLI */
          runoffuncorr(i,j) = 0d0
!          sumprecipnegat = sumprecipnegat + runoflECB(i,j)
#endif

! mab: epsl = 1e-10
          if (fractl(i,j).gt.epsl) then

            IF ((eni(i,j).EQ.0).OR.(enj(i,j).EQ.0)) THEN
              WRITE(*,*) "Probleme en : ", i,j, "!!", eni(i,j), enj(i,j)
              READ(*,*)
            ENDIF

#if ( ISOATM >= 2 )
!-----|--1--------2---------3---------4---------5---------6---------7-|
!      Computation of isotopic runoff
!     == No isotopic fractionation is considered here ==
!-----|--1--------2---------3---------4---------5---------6---------7-|
!mab: bmoism = maximum bottom moisture
          if (bmoisg(i,j,ieau).gt.bmoism(i,j)) then

#if ( ISOATM == 2 )
           DO k=ieau+1,neauiso
             bmoisg(i,j,k) = bmoisg(i,j,k) - 
     &((bmoisg(i,j,ieau)-bmoism(i,j))/bmoisg(i,j,ieau))*bmoisg(i,j,k)
             runofl(i,j,k)=(
     &((bmoisg(i,j,ieau)-bmoism(i,j))/bmoisg(i,j,ieau))*bmoisg(i,j,k)
     &)/dtland

           ENDDO
#if (1) 
          DO k=1, neauiso          
          if (bmoisg(i,j,k).LT.0.0d0) then
          WRITE(*,*) "WARN {{{: ",bmoisg(i,j,k),bmoisg(i,j,ieau),i,j,k
          WRITE(*,*) "bmoism: ", bmoism(i,j)
          endif
          ENDDO
#endif

#elif ( ISOATM == 3)
           WRITE(*,*) "OPTION non implementee, ec_runoff2"
#endif
              runofl(i,j,ieau)=(bmoisg(i,j,ieau)-bmoism(i,j))/dtland
              bmoisg(i,j,ieau)=bmoism(i,j)

          endif ! (bmoisg(i,j,ieau).gt.bmoism(i,j))

#else /* ISOATM < 2  thus no isotopes in runoff */

! mab/dmr : dtland = 3600*24/(iatm*ilan) = 14
! dmr: the unit of bmois is m
! dmr: runofl is hence there is m.s-1.step-1 (iland)
! dmr: input is thus consistent in using m.s-1

         if (bmoisg(i,j).gt.bmoism(i,j)) then
              runofl(i,j)=(bmoisg(i,j)-bmoism(i,j))/dtland
              bmoisg(i,j)=bmoism(i,j)

         endif ! on bmoisg > bmoism
#endif
#if ( DIAGNOSIS_FLAG == 1 )
#if ( ISOATM >= 2 )
          totallnd = totallnd + runofl(i,j,ieau)*dareas(i)*fractl(i,j)
#else
          totallnd = totallnd + runofl(i,j)*dareas(i)*fractl(i,j)
#endif
#endif
          endif

        enddo ! on j, nlon
      enddo ! on i, nlat

!      if(istp .eq. 1) print*,'ec_runoff, sumprecip: ',sumprecipnegat
!      if(iyear .gt. 1) print*,'iyear!: ',iyear
!      if(iyear .gt. 1) print*,'ec_runoff, sumprecip: ',sumprecipnegat

!-----|--1--------2---------3---------4---------5---------6---------7-|
!       Redistribution sur les cases de sortie ad hoc
!        On re-décrit les cases ECBilt pour trouver leurs sorties ...
!-----|--1--------2---------3---------4---------5---------6---------7-|


#if ( WATGRISCONS == 1 ) 
       irunlabelgris = irunlabel + iyear-1
      if (istp .eq. 1) then
         write(frunl,'(I6.6)') irunlabelgris
         inquire(file='startdata/mass_grisrunECB'//frunl//'.dat',
     &   exist=mexist)
         if(mexist) then
          write(*,*)'MEXIST IN RUNOFFLAND: ',mexist,frunl,irunlabelgris
           open(1050,file='startdata/mass_grisrunECB'//frunl//'.dat',
     &     form='unformatted')
           read(1050) mass_grisrunl
         else 
          write(*,*)'MEXIST IN RUNOFFLAND: ',mexist,frunl,irunlabelgris
           mass_grisrunl(:,:)=0d0
         endif
         close(1050)  
       runoflECB(:,:) = runoflECB(:,:) + mass_grisrunl(:,:)
       endif
#endif

      do i=1,nlat
        do j=1,nlon
      if ((fractl(i,j).gt.epsl)
     & ) then
#if ( ISOATM >= 2 )
          DO k=ieau,neauiso
          runofo(eni(i,j),enj(i,j),k)=runofo(eni(i,j),enj(i,j),k)
     &    + runofl(i,j,k) * fractl(i,j)/(1.0-fractl(eni(i,j),enj(i,j)))
     &    * dareas(i)/dareas(eni(i,j))
          ENDDO
#if ( 0 ) 
cdmr --- Background checking of fluxes ...
          k = ieau18
          variso(:) = runofo(eni(i,j),enj(i,j),:)
          varisonm = "runoforun"

          if ((variso(k)*variso(ieau)).LT.0.0d0) then
           WRITE(*,*) "Inconsistent sign in variso: ", varisonm
           WRITE(*,*) variso(k),variso(ieau)
          endif
         
          if (abs(variso(k)).gt.abs(variso(ieau)*1.0E-1)) then
            WRITE(*,*) "Too much isotopes in: ",varisonm, i,j
            WRITE(*,*) variso(k), variso(ieau)
            WRITE(*,*) delta(variso(:),k)
            READ(*,*)
          endif
#endif
#else /* ISOATM < 2  thus no isotopes in runoff */

          runofo(eni(i,j),enj(i,j))=runofo(eni(i,j),enj(i,j))
     &    + runofl(i,j) * fractl(i,j)/(1.0-fractl(eni(i,j),enj(i,j)))
     &    * dareas(i)/dareas(eni(i,j))

       flux_per_basin(river_basin(i,j))=flux_per_basin(river_basin(i,j))
     &    + runofl(i,j) * fractl(i,j) * dareas(i)

!mab: runoflECB is given by GRISLI in m3/yr -> has to be changed into
!     m / land time step
#if ( WATGRISCONS == 1 ) /* dmr: WATGRISCONS do not deal with isotopes yet */
!mab: if a restart file with mass from GRISLI is read in on the 1st day   

         runoffuncorr(eni(i,j),enj(i,j))=runoffuncorr(eni(i,j),enj(i,j))
     &    + runoflECB(i,j) * conv_fact/(
     &    dareas(eni(i,j))*(1.0-fractl(eni(i,j),enj(i,j)))
     &     )

      else ! we are on an ocean cell fully and  there is some GRISLI 
              ! runoff coming in directly
              ! This is needed because the ice-sheet can expand (ground) on the ocean
              ! (the land - sea mask is not YET updated consistently)

         runoffuncorr(i,j)=runoffuncorr(i,j) 
     &                     + runoflECB(i,j)*conv_fact/(
     &    dareas(i)*(1.d0-fractl(i,j))
     &     )

#endif /* On WATGRISCONS == 1 */

#endif /* On ISOATM <> 2 */


         
      endif ! on fractl > epsl
      enddo ! on j, nlon
      enddo ! on i, nlat

#if ( WATGRISCONS == 1 )
#if(1)
      IF (mod(istp,nstpyear).EQ.0) THEN ! end of year

       watconstest = 0d0

       DO i=1,nlat
        DO j=1,nlon
           watconstest =  watconstest 
     &    + runoffuncorr(i,j) / conv_fact *(
     &    dareas(i)*(1.0-fractl(i,j))
     &     )
        ENDDO
      ENDDO

       open(100,file='outputdata/ism/sumECrunoff.txt', 
     & form='formatted',access='append') 
!     & form='formatted',status='replace') 
       write(100,'(2F15.10)')
     &  ,sum(runoflECB(:,:))/1.d6*conv_fact
     &  ,(watconstest)/1.d6*conv_fact
        close(100)
      ENDIF
#endif

#if(0)
       open(100,file='runoffuncorr.dat', form='formatted'
     * ,position='append')
      do i=1,nlat
        do j=1,nlon
          if(runoffuncorr(i,j).ne.0d0)then
             write(100,'(I4,1F30.10)') istp,runoffuncorr(i,j)
          endif
        enddo
      enddo
      close(100)      
      open(100,file='runofo.dat', form='formatted'
     * ,status='replace')
      do i=1,nlat
        do j=1,nlon
          if(runofo(i,j).ne.0d0)then
             write(100,'(I4,1F30.10)') istp,runofo(i,j)
          endif
        enddo
      enddo
      close(100)  
# endif
# endif

#if ( DIAGNOSIS_FLAG == 1 )
!-----|--1--------2---------3---------4---------5---------6---------7-|
! dmr   Summarising water flux to the ocean cells
!       Warning: do not take into account the flux from mab in
!         RUNOFFGRIS since conditions is on fractl
! dmr   Practically, no impact since totaloc is not used anywhere
! dmr   Edit: Use this code only if DIAGNOSIS_FLAG set to 1
!-----|--1--------2---------3---------4---------5---------6---------7-|
      totaloc = 0
      do i=1,nlat
        do j=1,nlon
        if ((1.0-fractl(i,j)).gt.epsl) then
#if ( ISOATM >= 2 )
        totaloc = totaloc + runofo(i,j,ieau)*dareas(i)*(1.0-fractl(i,j))
#else
        totaloc = totaloc + runofo(i,j)*dareas(i)*(1.0-fractl(i,j))
#endif
        endif
        enddo
      enddo
#endif /* On DIAGNOSIS_FLAG */

!-----|--1--------2---------3---------4---------5---------6---------7-|
! dmr  Output the ruoff per defined land basins (initially for fjd)
!-----|--1--------2---------3---------4---------5---------6---------7-|

      IF (mod(istp,nstpyear).EQ.0) THEN ! end of year
        OPEN(777,                    
     &         file='outputdata/land/runoff_per_basin.txt',            
     &         form='formatted', access='append', status='unknown')
!dmr&fjd --- Output dimension is Km3/year
        WRITE(777,'(13E20.10)') flux_per_basin/nstpyear*31104000.0E0/1.0E9
        CLOSE(777)
        flux_per_basin = 0.0
      ENDIF

!-----|--1--------2---------3---------4---------5---------6---------7-|
! dmr   Finished business with runoff! 
!-----|--1--------2---------3---------4---------5---------6---------7-|

      return

      END SUBROUTINE ec_runoff_2
